<template>
    <div>
        <crumbs title="别名维护系统">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="标签名称：">
                    <el-input size="mini" v-model="filter.proName" placeholder="标签名称" clearable></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" @click="uploadClick">导入</el-button>
                    <input type="file" name="uploadfile " id="upFile" @change="uploadFile($event)" accept=".csv, application/vnd.ms-excel, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet">
                    <!-- <router-link to="/admin/LT-YXSJWH-TJBM" style="margin:0 10px">
                        <el-button size="mini" type="warning">添加别名</el-button>
                    </router-link> -->
                    <el-button size="mini" type="warning" style="margin:0 10px" @click="addName">添加别名</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        :resizable = "false"
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="gmtOperate"
                        label="操作时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="questionName"
                        label="标签名称"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="typeName"
                        label="归属"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="retrievalSelfName"
                        label="本体"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="retrievalNames"
                        label="别名"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="retrievalSonNames"
                        label="子项"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="operatorName"
                        label="操作人">
                </el-table-column>
                
                <el-table-column
                        :resizable = "false"
                        label="操作">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="toEditProduct(scope.row)">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" class="delete" @click="showDelDialog(scope.row.questionId)">删除</el-button>
                    </template>
                </el-table-column>
                <!-- <el-table-column
                        label="详情">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="getDetailList(scope.row.questionId)">详情</el-button>
                    </template>
                </el-table-column> -->
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/icss.js';
  export default {
    name: 'SimilarName',
    data: function () {
      return {
        list: [],
        cacheData: {},
        currentPage: 1,
        pageSize: 10,
        total: 0,
        linkIn:[],
        pays:[],
        filter: {
          proName: ''
        },
        optionList:[]
      }
    },
    created() {
      this.getOptions();
      this.getDataList();
    },
    methods: {
      getOptions(){//归属枚举
        api.getDropList().then((res)=>{
          const list = res.data;
          if(list.code==0){
            this.optionList = list.data[1];
          }else{
            /*this.$message({
              message:list.msg || '获取归属类型失败',
              type:'warning'
            });*/
            console.log(list.msg);
          }
        })
      },
      addName(){
        this.$router.push({
          name:'AddSimilarName',
          params:{optionList:this.optionList}
        })
      },
      toEditProduct(row){
        this.$router.push({
          name:'AddSimilarName',
          params: {id:row.questionId,name:row.questionName,optionList:this.optionList}
        })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList() {
        const param = this.getFilterItems();
        api.similarName(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            // 将questionType转文字
            let datas = data.records;
            const lists = this.optionList;
            if(lists.length>0){
              for(let i=0; i<datas.length; i++){
                for(let j=0; j<lists.length;j++){
                  if(datas[i].questionType== +lists[j].val){
                    datas[i].typeName=lists[j].name;
                  }
                }
              }
            }
            // this.list = data.records;
            // this.cacheData[param.current] = data.records;
            this.list = datas;
            this.cacheData[param.current] = datas;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getDetailList(id) {
        const param = {'id': id,};
        this.$router.push({name:'DeptInfoDetail', params:{id: id}})
        /*api.getDeptInfoDetials(param).then((res) => {
          if (res.data.code == '0') {
            this.$router.push({name:'DeptInfoDetail', params:{id: id}})
            // console.log("详情接口调用成功");
          } else {
            this.$message({
              showClose: true,
              message:res.data.msg,
              type:'warning'
            });
            this.getDataList()  //刷新列表
          }
        }).catch((error) => {
          console.log(error);
        });*/
      },
      getFilterItems() {
        const param = {
          questionName: this.filter.proName,
          current: this.currentPage,
          size: this.pageSize
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {
          this.getDataList();
        }
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(id){
        this.showConfirmDialog('是否删除该标签名？',()=>{
          api.delSimilarName({questionId:id}).then((res)=>{
            if(res.data.code=='0'){
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      },
      uploadClick(){
        let inp = document.getElementById("upFile");
        inp.click();
      },
      uploadFile(e){
        let fileInfo = e.target.files[0];
        e.preventDefault();
        let formData = new FormData();
        formData.append('uploadfile', fileInfo);
        const header = {
          headers:{
            'Content-Type': 'multipart/form-data'
          }
        }
        api.uploadFile(formData,header).then((res)=>{
          if(res.data.code==0){
            this.$message({
              message: '上传成功',
              type: 'success',
            });
          }else{
            this.$message({
              dangerouslyUseHTMLString: true,
              message:res.data.msg,
              type:'warning'
            });
          }
        })
        this.getDataList();
        //解决上传相同文件不触发change
        let inp = document.getElementById("upFile");
        inp.value = "";
      }
    }
  }
</script>

<style lang="less" scoped>
    @import "../../less/admin.less";
    .delete{
        color: red;
    }
    .el-table .cell{
      overflow: hidden;
      white-space: nowrap;
    }
    #upFile{
      display: none !important;
    }
</style>